6814aba4b22fef6c4a37c0e2d76ba04ce5af9803
[releng/global-jjb.git] / .jjb-test / expected-xml / gerrit-ciman-packer-merge-ubuntu1604-mininet
1 <?xml version="1.0" encoding="utf-8"?>
2 <project>
3   <actions/>
4   <description>&lt;!-- Managed by Jenkins Job Builder --&gt;</description>
5   <keepDependencies>false</keepDependencies>
6   <blockBuildWhenDownstreamBuilding>false</blockBuildWhenDownstreamBuilding>
7   <blockBuildWhenUpstreamBuilding>false</blockBuildWhenUpstreamBuilding>
8   <concurrentBuild>false</concurrentBuild>
9   <assignedNode>build-vm</assignedNode>
10   <canRoam>false</canRoam>
11   <properties>
12     <jenkins.model.BuildDiscarderProperty>
13       <strategy class="hudson.tasks.LogRotator">
14         <daysToKeep>7</daysToKeep>
15         <numToKeep>-1</numToKeep>
16         <artifactDaysToKeep>-1</artifactDaysToKeep>
17         <artifactNumToKeep>0</artifactNumToKeep>
18       </strategy>
19     </jenkins.model.BuildDiscarderProperty>
20     <hudson.model.ParametersDefinitionProperty>
21       <parameterDefinitions>
22         <hudson.model.StringParameterDefinition>
23           <name>PROJECT</name>
24           <description>Parameter to identify a Gerrit project. This is typically the
25 project repo path as exists in Gerrit.
26 For example: ofextensions/circuitsw
27 </description>
28           <defaultValue>releng/ciman</defaultValue>
29         </hudson.model.StringParameterDefinition>
30         <hudson.model.StringParameterDefinition>
31           <name>STREAM</name>
32           <description>Stream is often set to the same name as 'branch' but can
33 sometimes be used as a name representing a project's release code
34 name.
35 </description>
36           <defaultValue>master</defaultValue>
37         </hudson.model.StringParameterDefinition>
38         <hudson.model.StringParameterDefinition>
39           <name>GERRIT_PROJECT</name>
40           <description>Parameter to identify Gerrit project. This is typically the
41 project repo path as exists in Gerrit.
42 For example: ofextensions/circuitsw
43
44 Note that Gerrit will override this parameter automatically if a
45 job is triggered by Gerrit.
46 </description>
47           <defaultValue>releng/ciman</defaultValue>
48         </hudson.model.StringParameterDefinition>
49         <hudson.model.StringParameterDefinition>
50           <name>GERRIT_BRANCH</name>
51           <description>Parameter to identify a Gerrit branch.
52
53 Note that Gerrit will override this parameter automatically if a
54 job is triggered by Gerrit.
55 </description>
56           <defaultValue>master</defaultValue>
57         </hudson.model.StringParameterDefinition>
58         <hudson.model.StringParameterDefinition>
59           <name>GERRIT_REFSPEC</name>
60           <description>Parameter to identify a refspec when pulling from Gerrit.
61
62 Note that Gerrit will override this parameter automatically if a
63 job is triggered by Gerrit.
64 </description>
65           <defaultValue>refs/heads/master</defaultValue>
66         </hudson.model.StringParameterDefinition>
67         <hudson.model.StringParameterDefinition>
68           <name>LFTOOLS_VERSION</name>
69           <description>Version of lftools to install. Can be a specific version like
70 '0.6.0' or a PEP-440 definition.
71 https://www.python.org/dev/peps/pep-0440/
72 For example '&lt;1.0.0' or '&gt;=1.0.0,&lt;2.0.0'.
73 </description>
74           <defaultValue>&lt;1.0.0</defaultValue>
75         </hudson.model.StringParameterDefinition>
76         <hudson.model.StringParameterDefinition>
77           <name>PACKER_VERSION</name>
78           <description>Packer version to download and install.</description>
79           <defaultValue>1.1.3</defaultValue>
80         </hudson.model.StringParameterDefinition>
81       </parameterDefinitions>
82     </hudson.model.ParametersDefinitionProperty>
83   </properties>
84   <scm class="hudson.plugins.git.GitSCM">
85     <configVersion>2</configVersion>
86     <userRemoteConfigs>
87       <hudson.plugins.git.UserRemoteConfig>
88         <name>origin</name>
89         <refspec>$GERRIT_REFSPEC</refspec>
90         <url>$GIT_URL/$GERRIT_PROJECT</url>
91         <credentialsId>test-credential</credentialsId>
92       </hudson.plugins.git.UserRemoteConfig>
93     </userRemoteConfigs>
94     <branches>
95       <hudson.plugins.git.BranchSpec>
96         <name>refs/heads/$GERRIT_BRANCH</name>
97       </hudson.plugins.git.BranchSpec>
98     </branches>
99     <doGenerateSubmoduleConfigurations>false</doGenerateSubmoduleConfigurations>
100     <remotePoll>false</remotePoll>
101     <gitTool>Default</gitTool>
102     <submoduleCfg class="list"/>
103     <reference/>
104     <gitConfigName/>
105     <gitConfigEmail/>
106     <extensions>
107       <hudson.plugins.git.extensions.impl.BuildChooserSetting>
108         <buildChooser class="com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.GerritTriggerBuildChooser"/>
109       </hudson.plugins.git.extensions.impl.BuildChooserSetting>
110       <hudson.plugins.git.extensions.impl.SubmoduleOption>
111         <disableSubmodules>false</disableSubmodules>
112         <recursiveSubmodules>true</recursiveSubmodules>
113         <trackingSubmodules>false</trackingSubmodules>
114         <parentCredentials>false</parentCredentials>
115         <reference/>
116         <timeout>10</timeout>
117       </hudson.plugins.git.extensions.impl.SubmoduleOption>
118       <hudson.plugins.git.extensions.impl.WipeWorkspace/>
119     </extensions>
120   </scm>
121   <triggers class="vector">
122     <hudson.triggers.TimerTrigger>
123       <spec>00 10 1 * *</spec>
124     </hudson.triggers.TimerTrigger>
125     <com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.GerritTrigger>
126       <spec/>
127       <gerritProjects>
128         <com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.data.GerritProject>
129           <compareType>ANT</compareType>
130           <pattern>releng/ciman</pattern>
131           <branches>
132             <com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.data.Branch>
133               <compareType>ANT</compareType>
134               <pattern>**/master</pattern>
135             </com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.data.Branch>
136           </branches>
137           <filePaths>
138             <com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.data.FilePath>
139               <compareType>ANT</compareType>
140               <pattern>packer/vars/ubuntu1604.json</pattern>
141             </com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.data.FilePath>
142             <com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.data.FilePath>
143               <compareType>ANT</compareType>
144               <pattern>packer/templates/mininet.json</pattern>
145             </com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.data.FilePath>
146             <com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.data.FilePath>
147               <compareType>ANT</compareType>
148               <pattern>packer/provision/*.sh</pattern>
149             </com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.data.FilePath>
150             <com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.data.FilePath>
151               <compareType>ANT</compareType>
152               <pattern>packer/provision/mininet.yaml</pattern>
153             </com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.data.FilePath>
154             <com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.data.FilePath>
155               <compareType>ANT</compareType>
156               <pattern>packer/provision/lib/**</pattern>
157             </com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.data.FilePath>
158           </filePaths>
159           <disableStrictForbiddenFileVerification>false</disableStrictForbiddenFileVerification>
160         </com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.data.GerritProject>
161       </gerritProjects>
162       <skipVote>
163         <onSuccessful>false</onSuccessful>
164         <onFailed>false</onFailed>
165         <onUnstable>false</onUnstable>
166         <onNotBuilt>false</onNotBuilt>
167       </skipVote>
168       <silentMode>false</silentMode>
169       <silentStartMode>false</silentStartMode>
170       <escapeQuotes>true</escapeQuotes>
171       <noNameAndEmailParameters>false</noNameAndEmailParameters>
172       <readableMessage>false</readableMessage>
173       <dependencyJobsNames/>
174       <notificationLevel/>
175       <dynamicTriggerConfiguration>False</dynamicTriggerConfiguration>
176       <triggerConfigURL/>
177       <allowTriggeringUnreviewedPatches>false</allowTriggeringUnreviewedPatches>
178       <triggerOnEvents>
179         <com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.events.PluginChangeMergedEvent/>
180         <com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.events.PluginCommentAddedContainsEvent>
181           <commentAddedCommentContains>remerge$</commentAddedCommentContains>
182         </com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.events.PluginCommentAddedContainsEvent>
183       </triggerOnEvents>
184       <buildStartMessage/>
185       <buildFailureMessage/>
186       <buildSuccessfulMessage/>
187       <buildUnstableMessage/>
188       <buildNotBuiltMessage/>
189       <buildUnsuccessfulFilepath/>
190       <customUrl/>
191       <serverName>test-server</serverName>
192     </com.sonyericsson.hudson.plugins.gerrit.trigger.hudsontrigger.GerritTrigger>
193   </triggers>
194   <builders>
195     <org.jenkinsci.plugins.configfiles.builder.ConfigFileBuildStep plugin="config-file-provider">
196       <managedFiles>
197         <org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
198           <fileId>ci-packer-cloud-env</fileId>
199           <targetLocation/>
200           <variable>CLOUDENV</variable>
201         </org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
202       </managedFiles>
203     </org.jenkinsci.plugins.configfiles.builder.ConfigFileBuildStep>
204     <EnvInjectBuilder>
205       <info>
206         <propertiesContent>PACKER_VERSION=1.1.3
207 </propertiesContent>
208       </info>
209     </EnvInjectBuilder>
210     <hudson.tasks.Shell>
211       <command>#!/bin/bash
212 # SPDX-License-Identifier: EPL-1.0
213 ##############################################################################
214 # Copyright (c) 2017 The Linux Foundation and others.
215 #
216 # All rights reserved. This program and the accompanying materials
217 # are made available under the terms of the Eclipse Public License v1.0
218 # which accompanies this distribution, and is available at
219 # http://www.eclipse.org/legal/epl-v10.html
220 ##############################################################################
221 echo &quot;---&gt; packer-install.sh&quot;
222 # The script checks for the packer binaries and installs the binary
223 # if its not available
224
225 # $PACKER_VERSION        : Define a packer version passed as job paramter
226
227 PACKER_VERSION=&quot;${PACKER_VERSION:-1.1.3}&quot;
228
229 # Ensure we fail the job if any steps fail.
230 set -eu -o pipefail
231
232 if hash packer.io 2&gt;/dev/null; then
233     echo &quot;packer.io command is available.&quot;
234 else
235     echo &quot;packer.io command not is available. Installing packer ...&quot;
236     # Installs Hashicorp's Packer binary, required for verify &amp; merge packer jobs
237     pushd &quot;${WORKSPACE}&quot;
238     wget -nv &quot;https://releases.hashicorp.com/packer/${PACKER_VERSION}/packer_${PACKER_VERSION}_linux_amd64.zip&quot;
239     mkdir -p &quot;${WORKSPACE}/bin&quot;
240     unzip &quot;packer_${PACKER_VERSION}_linux_amd64.zip&quot; -d &quot;${WORKSPACE}/bin/&quot;
241     # rename packer to avoid conflict with binary in cracklib
242     mv &quot;${WORKSPACE}/bin/packer&quot; &quot;${WORKSPACE}/bin/packer.io&quot;
243     popd
244 fi
245
246 #!/bin/bash
247 # SPDX-License-Identifier: EPL-1.0
248 ##############################################################################
249 # Copyright (c) 2017 The Linux Foundation and others.
250 #
251 # All rights reserved. This program and the accompanying materials
252 # are made available under the terms of the Eclipse Public License v1.0
253 # which accompanies this distribution, and is available at
254 # http://www.eclipse.org/legal/epl-v10.html
255 ##############################################################################
256 echo &quot;---&gt; packer-validate.sh&quot;
257 # The script validates an packers files.
258
259 # $CLOUDENV            :  Provides the cloud credential file.
260
261 # Ensure we fail the job if any steps fail.
262 set -eu -o pipefail
263
264 PACKER_LOGS_DIR=&quot;$WORKSPACE/archives/packer&quot;
265 mkdir -p &quot;$PACKER_LOGS_DIR&quot;
266 export PATH=&quot;${WORKSPACE}/bin:$PATH&quot;
267
268 cd packer
269 varfiles=(vars/*.json common-packer/vars/*.json)
270 templates=(templates/*.json)
271
272 for varfile in &quot;${varfiles[@]}&quot;; do
273     # cloud-env.json is a file containing credentials which is pulled in via
274     # CLOUDENV variable so skip it here.
275     if [[ &quot;$varfile&quot; == *&quot;cloud-env.json&quot;* ]]; then
276         continue
277     fi
278
279     echo &quot;-----&gt; Testing varfile: $varfile&quot;
280     for template in &quot;${templates[@]}&quot;; do
281         export PACKER_LOG=&quot;yes&quot;
282         export PACKER_LOG_PATH=&quot;$PACKER_LOGS_DIR/packer-validate-${varfile##*/}-${template##*/}.log&quot;
283         if output=$(packer.io validate -var-file=&quot;$CLOUDENV&quot; -var-file=&quot;$varfile&quot; &quot;$template&quot;); then
284             echo &quot;$template: $output&quot;
285         else
286             echo &quot;$template: $output&quot;
287             exit 1
288         fi
289     done
290 done
291 </command>
292     </hudson.tasks.Shell>
293     <hudson.tasks.Shell>
294       <command>#!/bin/bash
295 # SPDX-License-Identifier: EPL-1.0
296 ##############################################################################
297 # Copyright (c) 2017 The Linux Foundation and others.
298 #
299 # All rights reserved. This program and the accompanying materials
300 # are made available under the terms of the Eclipse Public License v1.0
301 # which accompanies this distribution, and is available at
302 # http://www.eclipse.org/legal/epl-v10.html
303 ##############################################################################
304 echo &quot;---&gt; packer-clear-credentials.sh&quot;
305
306 set +e  # DO NOT cause build failure if any of the rm calls fail.
307 rm &quot;$CLOUDENV&quot;
308 exit 0
309 </command>
310     </hudson.tasks.Shell>
311     <org.jenkinsci.plugins.configfiles.builder.ConfigFileBuildStep plugin="config-file-provider">
312       <managedFiles>
313         <org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
314           <fileId>ci-packer-cloud-env</fileId>
315           <targetLocation/>
316           <variable>CLOUDENV</variable>
317         </org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
318       </managedFiles>
319     </org.jenkinsci.plugins.configfiles.builder.ConfigFileBuildStep>
320     <EnvInjectBuilder>
321       <info>
322         <propertiesContent>PACKER_PLATFORM=ubuntu1604
323 PACKER_TEMPLATE=mininet
324 PACKER_VERSION=1.1.3
325 </propertiesContent>
326       </info>
327     </EnvInjectBuilder>
328     <hudson.tasks.Shell>
329       <command>#!/bin/bash
330 # SPDX-License-Identifier: EPL-1.0
331 ##############################################################################
332 # Copyright (c) 2017 The Linux Foundation and others.
333 #
334 # All rights reserved. This program and the accompanying materials
335 # are made available under the terms of the Eclipse Public License v1.0
336 # which accompanies this distribution, and is available at
337 # http://www.eclipse.org/legal/epl-v10.html
338 ##############################################################################
339 echo &quot;---&gt; packer-install.sh&quot;
340 # The script checks for the packer binaries and installs the binary
341 # if its not available
342
343 # $PACKER_VERSION        : Define a packer version passed as job paramter
344
345 PACKER_VERSION=&quot;${PACKER_VERSION:-1.1.3}&quot;
346
347 # Ensure we fail the job if any steps fail.
348 set -eu -o pipefail
349
350 if hash packer.io 2&gt;/dev/null; then
351     echo &quot;packer.io command is available.&quot;
352 else
353     echo &quot;packer.io command not is available. Installing packer ...&quot;
354     # Installs Hashicorp's Packer binary, required for verify &amp; merge packer jobs
355     pushd &quot;${WORKSPACE}&quot;
356     wget -nv &quot;https://releases.hashicorp.com/packer/${PACKER_VERSION}/packer_${PACKER_VERSION}_linux_amd64.zip&quot;
357     mkdir -p &quot;${WORKSPACE}/bin&quot;
358     unzip &quot;packer_${PACKER_VERSION}_linux_amd64.zip&quot; -d &quot;${WORKSPACE}/bin/&quot;
359     # rename packer to avoid conflict with binary in cracklib
360     mv &quot;${WORKSPACE}/bin/packer&quot; &quot;${WORKSPACE}/bin/packer.io&quot;
361     popd
362 fi
363
364 #!/bin/bash
365 # SPDX-License-Identifier: EPL-1.0
366 ##############################################################################
367 # Copyright (c) 2017 The Linux Foundation and others.
368 #
369 # All rights reserved. This program and the accompanying materials
370 # are made available under the terms of the Eclipse Public License v1.0
371 # which accompanies this distribution, and is available at
372 # http://www.eclipse.org/legal/epl-v10.html
373 ##############################################################################
374 echo &quot;---&gt; packer-build.sh&quot;
375 # The script builds an image using packer
376 # $CLOUDENV            :  Provides the cloud credential file.
377 # $PACKER_PLATFORM     :  Provides the packer platform.
378 # $PACKER_TEMPLATE     :  Provides the packer temnplate.
379
380 # Ensure we fail the job if any steps fail.
381 set -eu -o pipefail
382
383 PACKER_LOGS_DIR=&quot;$WORKSPACE/archives/packer&quot;
384 PACKER_BUILD_LOG=&quot;$PACKER_LOGS_DIR/packer-build.log&quot;
385 mkdir -p &quot;$PACKER_LOGS_DIR&quot;
386 export PATH=&quot;${WORKSPACE}/bin:$PATH&quot;
387
388 # Prioritize the project's own version of vars if available
389 platform_file=&quot;vars/$PACKER_PLATFORM.json&quot;
390 if [ -f &quot;$PACKER_PLATFORM&quot; ]; then
391     platform_file=&quot;vars/$PACKER_PLATFORM.json&quot;
392 fi
393
394 cd packer
395 export PACKER_LOG=&quot;yes&quot;
396 export PACKER_LOG_PATH=&quot;$PACKER_BUILD_LOG&quot;
397 packer.io build -color=false \
398     -var-file=&quot;$CLOUDENV&quot; \
399     -var-file=&quot;$platform_file&quot; \
400     &quot;templates/$PACKER_TEMPLATE.json&quot;
401
402 # Retrive the list of cloud providers
403 mapfile -t clouds &lt; &lt;(jq -r '.builders[].name' &quot;templates/$PACKER_TEMPLATE.json&quot;)
404
405 # Split public/private clouds logs
406 for cloud in &quot;${clouds[@]}&quot;; do
407     grep -e &quot;$cloud&quot; &quot;$PACKER_BUILD_LOG&quot; &gt; &quot;$PACKER_LOGS_DIR/packer-build_$cloud.log&quot; 2&gt;&amp;1
408 done
409 </command>
410     </hudson.tasks.Shell>
411     <hudson.tasks.Shell>
412       <command>#!/bin/bash
413 # SPDX-License-Identifier: EPL-1.0
414 ##############################################################################
415 # Copyright (c) 2017 The Linux Foundation and others.
416 #
417 # All rights reserved. This program and the accompanying materials
418 # are made available under the terms of the Eclipse Public License v1.0
419 # which accompanies this distribution, and is available at
420 # http://www.eclipse.org/legal/epl-v10.html
421 ##############################################################################
422 echo &quot;---&gt; packer-clear-credentials.sh&quot;
423
424 set +e  # DO NOT cause build failure if any of the rm calls fail.
425 rm &quot;$CLOUDENV&quot;
426 exit 0
427 </command>
428     </hudson.tasks.Shell>
429   </builders>
430   <publishers>
431     <org.jenkinsci.plugins.postbuildscript.PostBuildScript>
432       <buildSteps>
433         <hudson.tasks.Shell>
434           <command>#!/bin/bash
435 # SPDX-License-Identifier: EPL-1.0
436 ##############################################################################
437 # Copyright (c) 2017 The Linux Foundation and others.
438 #
439 # All rights reserved. This program and the accompanying materials
440 # are made available under the terms of the Eclipse Public License v1.0
441 # which accompanies this distribution, and is available at
442 # http://www.eclipse.org/legal/epl-v10.html
443 ##############################################################################
444 echo &quot;---&gt; sysstat.sh&quot;
445 set +e  # DON'T fail build if script fails.
446
447 OS=$(facter operatingsystem)
448 case &quot;$OS&quot; in
449     Ubuntu)
450         SYSSTAT_PATH=&quot;/var/log/sysstat&quot;
451
452         # Dont run the script when systat is not enabled by default
453         if ! grep --quiet 'ENABLED=&quot;true&quot;' &quot;/etc/default/sysstat&quot;; then
454             exit 0
455         fi
456     ;;
457     CentOS|RedHat)
458         SYSSTAT_PATH=&quot;/var/log/sa&quot;
459     ;;
460     *)
461         # nothing to do
462         exit 0
463     ;;
464 esac
465
466 SAR_DIR=&quot;$WORKSPACE/archives/sar-reports&quot;
467 mkdir -p &quot;$SAR_DIR&quot;
468 cp &quot;$SYSSTAT_PATH/&quot;* &quot;$_&quot;
469 # convert sar data to ascii format
470 while IFS=&quot;&quot; read -r sarfilenum
471 do
472     [ -f &quot;$sarfilenum&quot; ] &amp;&amp; LC_TIME=POSIX sar -A -f &quot;$sarfilenum&quot; &gt; &quot;$SAR_DIR/sar${sarfilenum//[!0-9]/}&quot;
473 done &lt; &lt;(find &quot;$SYSSTAT_PATH&quot; -name &quot;sa[0-9]*&quot; || true)
474
475 # DON'T fail build if script fails.
476 exit 0
477 </command>
478         </hudson.tasks.Shell>
479         <org.jenkinsci.plugins.configfiles.builder.ConfigFileBuildStep plugin="config-file-provider">
480           <managedFiles>
481             <org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
482               <fileId>jenkins-log-archives-settings</fileId>
483               <targetLocation/>
484               <variable>SETTINGS_FILE</variable>
485             </org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
486           </managedFiles>
487         </org.jenkinsci.plugins.configfiles.builder.ConfigFileBuildStep>
488         <EnvInjectBuilder>
489           <info>
490             <propertiesContent>SERVER_ID=logs</propertiesContent>
491           </info>
492         </EnvInjectBuilder>
493         <hudson.tasks.Shell>
494           <command>#!/bin/bash
495 # SPDX-License-Identifier: EPL-1.0
496 ##############################################################################
497 # Copyright (c) 2017 The Linux Foundation and others.
498 #
499 # All rights reserved. This program and the accompanying materials
500 # are made available under the terms of the Eclipse Public License v1.0
501 # which accompanies this distribution, and is available at
502 # http://www.eclipse.org/legal/epl-v10.html
503 ##############################################################################
504 echo &quot;---&gt; create-netrc.sh&quot;
505
506 # Ensure we fail the job if any steps fail.
507 set -eu -o pipefail
508
509 NEXUS_URL=&quot;${NEXUSPROXY:-$NEXUS_URL}&quot;
510 CREDENTIAL=$(xmlstarlet sel -N &quot;x=http://maven.apache.org/SETTINGS/1.0.0&quot; \
511     -t -m &quot;/x:settings/x:servers/x:server[x:id='${SERVER_ID}']&quot; \
512     -v x:username -o &quot;:&quot; -v x:password \
513     &quot;$SETTINGS_FILE&quot;)
514
515 machine=$(echo &quot;$NEXUS_URL&quot; | awk -F/ '{print $3}')
516 user=$(echo &quot;$CREDENTIAL&quot; | cut -f1 -d:)
517 pass=$(echo &quot;$CREDENTIAL&quot; | cut -f2 -d:)
518
519 echo &quot;machine ${machine%:*} login $user password $pass&quot; &gt; ~/.netrc
520 </command>
521         </hudson.tasks.Shell>
522         <hudson.tasks.Shell>
523           <command>#!/bin/bash
524 # SPDX-License-Identifier: EPL-1.0
525 ##############################################################################
526 # Copyright (c) 2017 The Linux Foundation and others.
527 #
528 # All rights reserved. This program and the accompanying materials
529 # are made available under the terms of the Eclipse Public License v1.0
530 # which accompanies this distribution, and is available at
531 # http://www.eclipse.org/legal/epl-v10.html
532 ##############################################################################
533 echo &quot;---&gt; lftools-install.sh&quot;
534
535 # Script to install lftools via a version passed in via lf-infra-parameters
536 #
537 # Required parameters:
538 #
539 #     LFTOOLS_VERSION: Passed in via lf-infra-parameters configuration. Can be
540 #                      set to a strict version number like '1.2.3' or using
541 #                      PEP-440 definitions.
542 #
543 #                      Examples:
544 #                          &lt;1.0.0
545 #                          &gt;=1.0.0,&lt;2.0.0
546 #
547 # By default a released version of lftools should always be used.
548 # The purpose of the 2 variables below is so that lftools devs can test
549 # unreleased versions of lftools. There are 2 methods to install a dev version
550 # of lftools:
551 #
552 #     1) gerrit patch: Used to test a patch that has not yet been merged.
553 #                      To do this set something like this:
554 #                          LFTOOLS_MODE=gerrit
555 #                          LFTOOLS_REFSPEC=refs/changes/96/5296/7
556 #
557 #     2) git branch: Used to install an lftools version from a specific branch.
558 #                    To use this set the variables as follows:
559 #                          LFTOOLS_MODE=git
560 #                          LFTOOLS_REFSPEC=master
561 #
562 #     3) release : The intended use case and default setting.
563 #                  Set LFTOOLS_MODE=release, in this case LFTOOLS_REFSPEC is unused.
564
565 LFTOOLS_MODE=release  # release | git | gerrit
566 LFTOOLS_REFSPEC=master
567
568 # Ensure we fail the job if any steps fail.
569 # DO NOT set -u as virtualenv's activate script has unbound variables
570 set -e -o pipefail
571
572 virtualenv --quiet &quot;/tmp/v/lftools&quot;
573 # shellcheck source=/tmp/v/lftools/bin/activate disable=SC1091
574 source &quot;/tmp/v/lftools/bin/activate&quot;
575 pip install --quiet --upgrade pip
576
577 case $LFTOOLS_MODE in
578     gerrit)
579         git clone https://gerrit.linuxfoundation.org/infra/releng/lftools.git /tmp/lftools
580         pushd /tmp/lftools
581         git fetch origin &quot;$LFTOOLS_REFSPEC&quot;
582         git checkout FETCH_HEAD
583         pip install --quiet --upgrade -r requirements.txt
584         pip install --quiet --upgrade -e .
585         popd
586         ;;
587
588     git)
589         pip install --quiet --upgrade git+https://gerrit.linuxfoundation.org/infra/releng/lftools.git@&quot;$BRANCH&quot;
590         ;;
591
592     release)
593         if [[ $LFTOOLS_VERSION =~ ^[0-9] ]]; then
594             LFTOOLS_VERSION=&quot;==$LFTOOLS_VERSION&quot;
595         fi
596
597         pip install --quiet --upgrade &quot;lftools${LFTOOLS_VERSION}&quot;
598         ;;
599 esac
600
601 lftools --version
602
603 # pipdeptree prints out a lot of information because lftools pulls in many
604 # dependencies. Let's only print it if we want to debug.
605 # echo &quot;----&gt; Pip Dependency Tree&quot;
606 # pip install --quiet --upgrade pipdeptree
607 # pipdeptree
608
609 #!/bin/bash
610 # SPDX-License-Identifier: EPL-1.0
611 ##############################################################################
612 # Copyright (c) 2017 The Linux Foundation and others.
613 #
614 # All rights reserved. This program and the accompanying materials
615 # are made available under the terms of the Eclipse Public License v1.0
616 # which accompanies this distribution, and is available at
617 # http://www.eclipse.org/legal/epl-v10.html
618 ##############################################################################
619 echo &quot;---&gt; logs-deploy.sh&quot;
620
621 # Ensure we fail the job if any steps fail.
622 set -eu -o pipefail
623
624 set -x  # Trace commands for this script to make debugging easier.
625
626 ARCHIVE_ARTIFACTS=&quot;${ARCHIVE_ARTIFACTS:-}&quot;
627 LOGS_SERVER=&quot;${LOGS_SERVER:-None}&quot;
628
629 if [ &quot;${LOGS_SERVER}&quot; == 'None' ]
630 then
631     set +x # Disable trace since we no longer need it
632
633     echo &quot;WARNING: Logging server not set&quot;
634 else
635     NEXUS_URL=&quot;${NEXUSPROXY:-$NEXUS_URL}&quot;
636     NEXUS_PATH=&quot;${SILO}/${JENKINS_HOSTNAME}/${JOB_NAME}/${BUILD_NUMBER}&quot;
637     BUILD_URL=&quot;${BUILD_URL}&quot;
638
639     lftools deploy archives -p &quot;$ARCHIVE_ARTIFACTS&quot; &quot;$NEXUS_URL&quot; &quot;$NEXUS_PATH&quot; &quot;$WORKSPACE&quot;
640     lftools deploy logs &quot;$NEXUS_URL&quot; &quot;$NEXUS_PATH&quot; &quot;$BUILD_URL&quot;
641
642     set +x  # Disable trace since we no longer need it.
643
644     echo &quot;Build logs: &lt;a href=\&quot;$LOGS_SERVER/$NEXUS_PATH\&quot;&gt;$LOGS_SERVER/$NEXUS_PATH&lt;/a&gt;&quot;
645 fi
646 </command>
647         </hudson.tasks.Shell>
648         <hudson.tasks.Shell>
649           <command>#!/bin/bash
650 # SPDX-License-Identifier: EPL-1.0
651 ##############################################################################
652 # Copyright (c) 2017 The Linux Foundation and others.
653 #
654 # All rights reserved. This program and the accompanying materials
655 # are made available under the terms of the Eclipse Public License v1.0
656 # which accompanies this distribution, and is available at
657 # http://www.eclipse.org/legal/epl-v10.html
658 ##############################################################################
659
660 # Clear log credential files
661 rm &quot;$SETTINGS_FILE&quot;
662 rm ~/.netrc
663 </command>
664         </hudson.tasks.Shell>
665         <hudson.plugins.descriptionsetter.DescriptionSetterBuilder>
666           <regexp>^Build logs: .*</regexp>
667         </hudson.plugins.descriptionsetter.DescriptionSetterBuilder>
668       </buildSteps>
669       <scriptOnlyIfSuccess>false</scriptOnlyIfSuccess>
670       <scriptOnlyIfFailure>false</scriptOnlyIfFailure>
671       <markBuildUnstable>false</markBuildUnstable>
672     </org.jenkinsci.plugins.postbuildscript.PostBuildScript>
673     <hudson.plugins.ws__cleanup.WsCleanup plugin="ws-cleanup">
674       <patterns>
675         <hudson.plugins.ws__cleanup.Pattern>
676           <pattern>**/*.jenkins-trigger</pattern>
677           <type>EXCLUDE</type>
678         </hudson.plugins.ws__cleanup.Pattern>
679       </patterns>
680       <deleteDirs>false</deleteDirs>
681       <cleanupMatrixParent>false</cleanupMatrixParent>
682       <externalDelete/>
683       <cleanWhenSuccess>true</cleanWhenSuccess>
684       <cleanWhenUnstable>true</cleanWhenUnstable>
685       <cleanWhenFailure>true</cleanWhenFailure>
686       <cleanWhenNotBuilt>true</cleanWhenNotBuilt>
687       <cleanWhenAborted>true</cleanWhenAborted>
688       <notFailBuild>true</notFailBuild>
689     </hudson.plugins.ws__cleanup.WsCleanup>
690   </publishers>
691   <buildWrappers>
692     <com.michelin.cio.hudson.plugins.maskpasswords.MaskPasswordsBuildWrapper/>
693     <hudson.plugins.build__timeout.BuildTimeoutWrapper>
694       <timeoutMinutes>45</timeoutMinutes>
695       <timeoutEnvVar>BUILD_TIMEOUT</timeoutEnvVar>
696       <failBuild>true</failBuild>
697       <writingDescription>false</writingDescription>
698       <timeoutPercentage>0</timeoutPercentage>
699       <timeoutMinutesElasticDefault>3</timeoutMinutesElasticDefault>
700       <timeoutType>absolute</timeoutType>
701     </hudson.plugins.build__timeout.BuildTimeoutWrapper>
702     <hudson.plugins.timestamper.TimestamperBuildWrapper/>
703     <com.cloudbees.jenkins.plugins.sshagent.SSHAgentBuildWrapper>
704       <user>test-credential</user>
705     </com.cloudbees.jenkins.plugins.sshagent.SSHAgentBuildWrapper>
706     <jenkins.plugins.openstack.compute.JCloudsOneOffSlave/>
707     <org.jenkinsci.plugins.configfiles.buildwrapper.ConfigFileBuildWrapper plugin="config-file-provider">
708       <managedFiles>
709         <org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
710           <fileId>npmrc</fileId>
711           <targetLocation>$HOME/.npmrc</targetLocation>
712           <variable/>
713         </org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
714       </managedFiles>
715     </org.jenkinsci.plugins.configfiles.buildwrapper.ConfigFileBuildWrapper>
716   </buildWrappers>
717 </project>